from ..utils.memcache import Memcache


class AlertGateway:

    @classmethod
    def getAlertInMemcache(cls, service, level, content):
        finalContent = cls._getFinalContent(service=service, level=level, content=content)
        return Memcache.get(finalContent)

    @classmethod
    def saveAlertInMemcache(cls, service, level, content, cooldown=3*3600):
        finalContent = cls._getFinalContent(service=service, level=level, content=content)
        Memcache.set(key=finalContent, value="sent", time=cooldown)

    @staticmethod
    def _getFinalContent(service, level, content):
        return "[{service}][{level}]{content}".format(
            service=service,
            level=level,
            content=content,
        )
