from ..utils.alert import Alert
from ..utils.microservices import Environment


def alertCrash(func):
    def wrapper(self, *args, **data):
        try:
            return func(self, *args, **data)
        except Exception as e:
            Alert.send(text="[{environment}] Crash handler: {className}".format(
                environment=Environment.current(),
                className=self.__class__.__name__
            ))
            raise e
    return wrapper
