from google.appengine.datastore.datastore_query import Cursor


def validateCursor(func):
    def wrapper(self, *args, **data):
        cursor = self.getParameter("cursor")
        data.update({
            "cursor": _getCursor(cursor)
        })
        func(self, *args, **data)
    return wrapper


def _getCursor(cursor):
    if not cursor or cursor in ["None", "null", "nil"]:
        return None
    try:
        return Cursor(urlsafe=cursor)
    except:
        return None
