from ..utils.apiMessage import SharedApiCode, SharedApiMessageKey


maxLimit = 100


def validateLimit(func):
    def wrapper(self, **data):
        limit = self.getParameter("limit", maxLimit)

        try:
            limit = float(limit)
            if not limit.is_integer():
                raise ValueError()

            limit = int(limit)
            if limit <= 0 or limit > maxLimit:
                raise ValueError()
        except:
            return self.sendJson(self.responseJson().error(
                code=SharedApiCode.invalidLimit,
                messageKey=SharedApiMessageKey.invalidLimit,
                maxLimit=maxLimit,
            ))

        data["limit"] = limit

        return func(self, **data)
    return wrapper
