from functools import wraps
from ..utils.permission import WorkspaceRole


def requiredPermission(permission, code, messageKey):
    def decorator(func):
        @wraps(func)
        def wrapper(self, **data):
            userRoles = self.userRoles()
            if not userRoles or WorkspaceRole.contains(permission=permission, inRoles=userRoles):
                return func(self, **data)
            return self.sendJson(
                self.responseJson().error(code=code, messageKey=messageKey)
            )
        return wrapper
    return decorator