from ..utils.apiMessage import SharedApiCode, SharedApiMessageKey


def validateQueryString(*validParameters):
    validParameters = set(validParameters)

    def decorator(func):
        def wrapper(self, **data):
            queryStringParams = [str(keyValue[0]) for keyValue in self.request.GET.items()]

            unknownParameters = set(queryStringParams) - validParameters
            if unknownParameters:
                return self.sendJson(self.responseJson().error(
                    code=SharedApiCode.invalidQueryString,
                    messageKey=SharedApiMessageKey.invalidParameters,
                    parameters=", ".join(sorted(list(unknownParameters))),
                ))

            for param in set(queryStringParams):
                queryStringParams.remove(param)
            if queryStringParams:
                return self.sendJson(self.responseJson().error(
                    code=SharedApiCode.invalidQueryString,
                    messageKey=SharedApiMessageKey.repeatedParameters,
                    parameters=", ".join(sorted(list(set(queryStringParams)))),
                ))

            return func(self, **data)
        return wrapper
    return decorator
