from darwin.models.sort import Sort
from darwin.utils.apiMessage import SharedApiCode, SharedApiMessageKey


def validateOptionalSort(func):
    def wrapper(self, **data):
        sort = self.getParameter("sort").lower()

        if sort and not Sort.isValid(sort):
            return self.sendJson(
                self.responseJson().error(
                    code=SharedApiCode.invalidSort,
                    messageKey=SharedApiMessageKey.invalidSort,
                    sorts=",".join(Sort.values())
                )
            )

        data.update({
            "sort": sort if sort else Sort.createdDesc
        })

        return func(self, **data)
    return wrapper
