from ..utils.apiMessage import SharedApiCode, SharedApiMessageKey
from ..utils.string import String


def validateOptionalQueryTags(func):
    def wrapper(self, **data):
        tags = [tag.strip().lower() for tag in self.getParameter("tags", "").split(",") if tag.strip()]

        tags, error = validateOptionalTags(self, tags=tags)
        if error:
            return self.sendJson(
                self.responseJson().errors(errors=[error])
            )

        data.update({
            "tags": tags
        })

        return func(self, **data)
    return wrapper


def validateOptionalTags(self, tags, index=None):
    if not tags:
        return [], None
    if not isinstance(tags, list):
        return [], self.responseJson().errorElement(
            code=SharedApiCode.invalidTags,
            messageKey=SharedApiMessageKey.notArray,
            parameter="tags",
            index=index,
        )
    if String.isNonStringOrEmpty(*tags):
        return [], self.responseJson().errorElement(
            code=SharedApiCode.invalidTags,
            messageKey=SharedApiMessageKey.notString,
            parameter="tags",
            index=index
        )
    return [tag.strip().lower() for tag in tags if tag.strip()], None
