from .error import ErrorModel


class ApiResponse:

    def __init__(self, language, messages):
        self.messages = messages
        self.language = language

    def message(self, messageKey, **data):
        return self.messages.get(key=messageKey, language=self.language, **data)

    def error(self, code, messageKey, **data):
        return ErrorModel.new(message=self.message(messageKey, **data), code=code)

    def errors(self, errors):
        return ErrorModel.array(elements=errors)

    def errorElement(self, code, messageKey, **data):
        return ErrorModel.element(message=self.message(messageKey, **data), code=code)

    def success(self, messageKey, **data):
        return {
            "message": self.message(messageKey, **data)
        }
