import unicodedata


class Accents:

    @classmethod
    def remove(cls, text):
        """
        Strip accents from input String.

        :param text: The input string.
        :type text: String.

        :returns: The processed String.
        :rtype: String.
        """

        if not isinstance(text, unicode):
            text = unicode(text, 'utf-8')

        text = unicodedata.normalize('NFD', text)
        text = text.encode('ascii', 'ignore')
        text = text.decode("utf-8")
        return str(text)