from google.appengine.api import memcache


class Memcache:

    @classmethod
    def get(cls, key):
        return memcache.get(key=key)

    @classmethod
    def getMulti(cls, keys):
        return memcache.get_multi(keys=keys)

    @classmethod
    def set(cls, key, value, time):
        return memcache.set(key=key, value=value, time=time)

    @classmethod
    def setMulti(cls, valueMapping, time):
        return memcache.set_multi(mapping=valueMapping, time=time)

    @classmethod
    def delete(cls, key):
        return memcache.delete(key)

    @classmethod
    def deleteMulti(cls, keys):
        return memcache.delete_multi(keys=keys)

    @classmethod
    def offset(cls, key, delta, initialValue=None):
        return cls.offsetMulti(
            {key: delta},
            initialValue=initialValue
        )[key]

    @classmethod
    def offsetMulti(cls, keyMap, initialValue=None):
        return memcache.offset_multi(keyMap, initial_value=initialValue)
