from json import loads, dumps
from .request import Request, POST
from ..gateways.auth import AuthGateway


class Slack:

    @classmethod
    def send(cls, text, sender, channel):
        data = {
            "text": text,
            "channel": channel,
            "username": sender,
        }

        response = Request.fetch(
            url=AuthGateway.getJsonCredentials("slack")["hook"],
            method=POST,
            body=dumps(data),
            headers={"Content-Type": "application/json"}
        )

        if response.status != 200:
            raise Exception(
                "Request to slack returned an error {code}, the response is: {content}".format(
                    code=response.status,
                    content=response.content
                )
            )

        return response
